#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <float.h>

typedef FILE* FioFile;

#define UT_UNIT_MANT_POS 0
#define UT_VERBOSE_UNIT 5

#define UT_FALSE 0
#define UT_TRUE  1
#define UT_SZ_P (sizeof(char*))
#define UT_SZ_D (sizeof(double))
#define UT_SZ_I (sizeof(long))
#define UT_SZ_C (sizeof(char))
#define WORD_SIZE 32
#define CARD_SIZE 80
#define TEXT_SIZE 1024
#define UT_UDF_MAX 100
#define UT_UNIT_MAX 20
typedef int logical;
typedef char TextWord[WORD_SIZE];
typedef char TextCard[CARD_SIZE];
typedef char TextBuf[TEXT_SIZE];
#define UT_ERR_UNIT_PARSE -100
#include "unitproto.h"

void cs_remove_nl( char* ptr );
void fio_dashline( long n );
char** ar_realloc_c( char** word, const long size, const long n );
logical ut_dbg_level( const long i );
void cs_copy( const char* src, char* dest );
int cs_is_blank( const char* a );
void cs_upper( char* buf );
double tpow_d( const long n );
void cs_get_c( char** buf, char* token, const long siz );
void cs_get_cs( char** buf, char* token, const long siz );
int cs_eq( const char* a, const char* b );
void fio_tmsg( char* buf );
long cs_index_char( const char* a, const char b );
int cs_index( const char* a , const char* b );
long cs_ends( const char* a );
void si_check( char* unit, long* factor, long* pos );
void cs_detab( char* buf );
void ar_free_c( char** word );
char** ar_alloc_c( const long size, const long n);
void cs_copy_siz( const char* a, char* b, long siz );
double cs_read_d( char* a );
logical cs_digit_char(   const char c );
void si_getpfx( long exponent, char* p, long* r );
void frac_d( const double g, long* vi, double* f );
void cs_put_d( const double t, char** p, long* s );
void cs_put_c( const char*  t, char** p, long* s );
void cs_put_cn( const char*  t, char** p, long* s );
char* cs_write_d( const double x, char* buf2, const long siz );
void ut_err_util( char* buf, long code );

long ar_cmatch_c( const char* buf, char** p, const long n );
void si_tmult( long fac1, double exponent1, long fac2, double exponent2, long* fac, double* mantissa );
logical cs_eq_ss( const char* buf, const long pos1, const long pos2, const char* comp );
logical cs_eq_siz( const char* ibuf1, const char* ibuf2, const long rsiz );
void cs_put_ss( const char* isource, char* dest, const long pos1, const long pos2 );
long rmod_i( const long value, long* remainder, const long divisor );







FioFile fio_open_ar( const char* filename );
logical fio_read_line( FioFile file, char* line, long lmax );
logical fio_file_close( FioFile file );
