#include <stdio.h>
#include "unitlib.h"

#define NMAX 10
#define SIZ  1024
void disp( char* opt, char** stack, long n );

int main( int nargs, char* args[] )
{
 char opt[80]="";
 char line[SIZ];
 char** stack;
 char* ptr;
 double power;
 long n=0;

 FILE* infile = stdin;
 char temp[SIZ]="";
 UnitDomain u = NULL;
 long i;
 int ok = 1;

 if ( nargs > 1 )
 {
  ptr = args[1];
  cs_get_c( &ptr, temp, NMAX );
  infile = fio_open_ar( temp );
 }
 stack = calloc( NMAX, sizeof( char* ));
 for ( i = 0; i < NMAX; i++ )
  stack[i] = calloc( SIZ, sizeof( char* ));
 printf( "Jonathan's Physical Unit Prototype Calculator\n" );
 
 while( opt[0] != 'Q' )
 { 
  if ( infile == stdin ) 
   printf( "Unity> " );
  ok = fio_read_line( infile, line, SIZ );

  if ( infile != stdin ) 
  {
   if ( !ok )
   {
    printf( "EOF\n" );
    fio_file_close( infile );
    infile = stdin;
   }
  }

  ptr = line;
  while( *ptr == ' ' ) ptr++;
  cs_get_c( &ptr, opt, 80 );
  cs_upper( opt );
  if ( cs_is_blank( opt ))
   continue;
  else if ( cs_eq( opt, "PUSH" ))
  {
   if ( !u ) u = cs_unit_init( NULL );
   n++;
   if ( n > NMAX ) n = NMAX;
   cs_get_cs( &ptr, stack[n-1], SIZ );
   printf( "PUSH %s\n", stack[n-1] );
  } 
  else if ( cs_eq( opt, "POP" ))
  {
   n--;
   if ( n < 0 ) n = 0;
   disp( opt, stack, n );
  } 
  else if ( cs_eq( opt, "MULT" ))
  {
   if ( n> 1 ) 
   {
    cs_unit_mult (u, stack[n-2], stack[n-1], temp, SIZ );
    printf( "MULT    %s * %s = %s\n", stack[n-2],stack[n-1], temp );
    cs_copy( temp, stack[n-2] );
    n--;
   }
  } 
  else if ( cs_eq( opt, "DIV" ) ) 
  {
   if ( n > 1 ) 
   {
    cs_unit_div( u, stack[n-2], stack[n-1], temp, SIZ );
    printf( "DIV %s / %s = %s\n", stack[n-2], stack[n-1], temp );
    cs_copy( temp, stack[n-2] );
    n--;
   }
  }  
  else if ( cs_eq( opt, "POWER" ) )
  {
   cs_get_c( &ptr, temp, SIZ );
   power = atof( temp );
   if (n > 0 ) 
   {
	cs_unit_exp ( u, stack[n-1],power,temp, SIZ);
        printf( "POWER   %s ** %f = %s\n", stack[n-1], power, temp );
        cs_copy( temp, stack[n-1] );
   }
  }
  else if ( cs_eq( opt, "TEX+" )) 
     cs_unit_texmode( u, 1 ); 
  else if ( cs_eq( opt, "TEX-" )) 
     cs_unit_texmode( u, 0 ); 
  else if ( cs_eq( opt, "RESOLVE" )) 
  {
     if( n > 0 )
     {
      cs_unit_resolve( u, stack[n-1], temp, SIZ );
      printf( "RESOLVE %s      = %s\n", stack[n-1], temp );
      cs_copy( temp, stack[n-1] );
     }
  } 
  else if ( cs_eq( opt, "STACK" ))
  {
     disp( opt, stack, n );
  } 
  else if ( cs_eq( opt, "DEFS" ))
  {
    cs_get_c( &ptr, temp, NMAX );
    u = cs_unit_init( temp );
    printf( "DEFS %s\n", temp );
  }
  else if ( cs_eq( opt, "PARSE" ) )
  {
     if ( n > 0 )
     {
      cs_unit_dparse( u, stack[n-1], temp, SIZ );
      cs_copy( temp, stack[n-1] );
      disp (opt,stack,n);
     }
  }
  else if ( opt[0] == '#' )
  {
   continue; /* Comment */
  }
  else if ( cs_eq( opt, "INPUT" ))
  {
    cs_get_c( &ptr, temp, NMAX );
    infile = fio_open_ar( temp );
  }
  else if ( opt[0] != 'Q' )
    {
      printf( "Bad command: %s\n", opt );
    }
 }
 cs_unit_free( u );
 exit (0);
}

void disp( char* opt, char** stack, long n )
{
 long i;
 if ( n> 0 )
  {
    printf( "%s\n", opt );
    for ( i = n; i >= 1; i-- )
     printf( "%s\n", stack[i-1] );
    printf( " \n" );
  }
}
