/* Internal unit routines */
#ifndef UNIT_REG_H
#define UNIT_REG_H

typedef struct {
 long n;
 long nmax;
 char** base;
 double* exp;
 long* fac;
} UnitRegister;

struct  UnitDomain_s {
 char** unit;
 char** def;
 long n;
 logical texmode;
 UnitRegister* ureg1;
 UnitRegister* ureg2;
};

void unit_free( UnitRegister* unit );
UnitRegister* unit_alloc( long n );
void unit_regmult( UnitRegister* reg1, UnitRegister* reg2, long power2 );
void unit_regdedup( UnitRegister* reg, UnitRegister* temp );
void unit_regcompose( UnitRegister* reg, logical texmode, char* unit, long siz );
void unit_regresolve( UnitDomain u );
void unit_ddisp( UnitRegister* reg );
void unit_regexp( UnitRegister* reg, double power );
void cs_unit_si_resolve( char** unit, long n, char** d_unit, long dn, long* fac );
void cs_unit_regparse( UnitDomain u, const char* unit, UnitRegister* reg );
void cs_unit_parse( const char* unit, UnitRegister* reg );
void cs_unit_reg_enlarge( UnitRegister* reg, long n );
#endif
